<?php

/**
 *  @package     Impera CMS
 *  @file        PayAnyWay payment module
 *  @version     1.0
 *  @author      Timur Sabiryanov, Russia
 *  @copyright   Copyright 2016, платёжный сервис «PayAnyWay»
 *  @link        https://payanyway.ru/
 */

// подключаем подложку платежного модуля (легальный запуск)
$legalStart = TRUE;
require_once(dirname(__FILE__) . '/Substrate.php');

class PayAnyWay extends PaymentModuleSubstrate {

	// имя модуля
	protected $marker = 'PayAnyWay';

	const MNT_ANSWER_SUCCESS = "SUCCESS";
	const MNT_ANSWER_FAIL = "FAIL";

	/**
	 * Обработка входных параметров
	 *
	 * @return mixed|string
	 */
	public function process () {

		// начинаем оплату
		$status =  $this->startPayment(
			'MNT_TRANSACTION_ID',
			self::MNT_ANSWER_FAIL,
			self::MNT_ANSWER_FAIL,
			self::MNT_ANSWER_FAIL,
			// ID способа оплаты
			'MNT_CUSTOM1',
			self::MNT_ANSWER_FAIL,
			self::MNT_ANSWER_FAIL,
			self::MNT_ANSWER_FAIL,
			// контрольная подпись
			'MNT_SIGNATURE',
			self::MNT_ANSWER_FAIL,
			// сумма оплаты
			'MNT_AMOUNT',
			self::MNT_ANSWER_FAIL,
			self::MNT_ANSWER_FAIL,
			// секретный ключ (из параметров способа оплаты)
			'payanyway_secret',
			self::MNT_ANSWER_FAIL);

		if (is_string($status))
			return $status;

		// проверяем контрольную подпись
		$mnt_id = $this->getObjectField($this->method->params, "payanyway_login");
		$mnt_transaction_id = $this->id;
		$mnt_amount = $this->sum;
		$mnt_operation_id = $this->getPostParam("MNT_OPERATION_ID");
		$mnt_currency_code = $this->getPostParam("MNT_CURRENCY_CODE");
		$mnt_subscriber_id = $this->getPostParam("MNT_SUBSCRIBER_ID");
		$mnt_testmode = $this->getObjectField($this->method->params, "payanyway_testmode");

		$mnt_signature = strtoupper(md5(
			$mnt_id.
			$mnt_transaction_id.
			$mnt_operation_id.
			$mnt_amount.
			$mnt_currency_code.
			$mnt_subscriber_id.
			$mnt_testmode.
			$this->secret
		));

		if ($mnt_signature != $this->sign)
			return self::MNT_ANSWER_FAIL;

		// проверяем наличие товаров
		$status = $this->checkOrderProducts($this->order);
		if (is_string($status))
			return $status;

		// завершаем оплату
		$this->finalizePayment($this->order, $this->pay_id, $this->marker);

		return self::MNT_ANSWER_SUCCESS;
	}
}

/**
 *  Внеклассовая часть программного кода
 */

$module = new PayAnyWay();

echo $module->process();
exit;
